{% block form %}
    {% import "@SonataAdmin/CRUD/base_edit_form_macro.html.twig" as form_helper %}
    {{ sonata_block_render_event('sonata.admin.edit.form.top', { 'admin': admin, 'object': object }) }}

    {# NEXT_MAJOR: remove default filter #}
    {% set url = 'generate' %}

    {% if not admin.hasRoute(url)%}
        <div>
            {{ "form_not_available"|trans({}, "SonataAdminBundle") }}
        </div>
    {% else %}
        <form
                {% if sonata_admin.adminPool.getOption('form_type') == 'horizontal' %}class="form-horizontal"{% endif %}
                role="form"
                {# NEXT_MAJOR: remove default filter #}
                action="{% block sonata_form_action_url %}{{ admin.generateUrl(url, {'id': objectId|default(admin.id(object)), 'uniqid': admin.uniqid, 'subclass': app.request.get('subclass')}) }}{% endblock %}"
                {% if form.vars.multipart %} enctype="multipart/form-data"{% endif %}
                method="POST"
                {% if not sonata_admin.adminPool.getOption('html5_validate') %}novalidate="novalidate"{% endif %}
                {% block sonata_form_attributes %}{% endblock %}
        >

            {{ include('@SonataAdmin/Helper/render_form_dismissable_errors.html.twig') }}

            {% block sonata_pre_fieldsets %}
            <div class="row">
                {% endblock %}

                {% block sonata_tab_content %}
                    {% set has_tab = ((admin.formtabs|length == 1 and admin.formtabs|keys[0] != 'default') or admin.formtabs|length > 1 ) %}

                    <div class="col-md-12">
                        {% if has_tab %}
                            <div class="nav-tabs-custom">
                                <ul class="nav nav-tabs" role="tablist">
                                    {% for name, form_tab in admin.formtabs %}
                                        {% set _tab_name = 'tab_'~admin.uniqid~'_'~loop.index %}
                                        <li{% if (not app.request.query.has('_tab') and loop.index == 1) or (app.request.query.get('_tab') == _tab_name) %} class="active"{% endif %}>
                                            <a href="#{{ _tab_name }}" class="changer-tab" aria-controls="{{ _tab_name }}" data-toggle="tab">
                                                <i class="fa fa-exclamation-circle has-errors hide" aria-hidden="true"></i> {{ form_tab.label|trans({}, form_tab.translation_domain ?: admin.translationDomain) }}
                                            </a>
                                        </li>
                                    {% endfor %}
                                </ul>
                                <div class="tab-content">
                                    {% for code, form_tab in admin.formtabs %}
                                        {% set _tab_name = 'tab_'~admin.uniqid~'_'~loop.index %}
                                        <div class="tab-pane fade{% if (not app.request.query.has('_tab') and loop.first) or (app.request.query.get('_tab') == _tab_name) %} in active{% endif %}" id="{{ _tab_name }}">
                                            <div class="box-body  container-fluid">
                                                <div class="sonata-ba-collapsed-fields">
                                                    {% if form_tab.description != false %}
                                                        <p>
                                                            {{ form_tab.description|trans({}, form_tab.translation_domain ?: admin.translationDomain) }}
                                                        </p>
                                                    {% endif %}

                                                    {{ form_helper.render_groups(admin, form, form_tab['groups'], has_tab) }}
                                                </div>
                                            </div>
                                        </div>
                                    {% endfor %}
                                </div>
                            </div>
                        {% else %}
                            {{ form_helper.render_groups(admin, form, admin.formtabs['default'].groups, has_tab) }}
                        {% endif %}
                    </div>
                {% endblock %}

                {% block sonata_post_fieldsets %}
            </div>
            {% endblock %}

            {{ form_rest(form) }}

            {% block formactions %}
                <div class="sonata-ba-form-actions well well-small form-actions">

                    <button type="submit" class="btn btn-success" name="btn_generate"><i class="fa fa-plus-circle" aria-hidden="true"></i> {{ 'Generate'|trans({}, 'SonataAdminBundle') }}</button>
                    <a class="btn btn-warning" href="{{ admin.generateUrl('list') }}">Cancel</a>

                </div>
            {% endblock formactions %}
        </form>
    {% endif%}

    {{ sonata_block_render_event('sonata.admin.edit.form.bottom', { 'admin': admin, 'object': object }) }}

{% endblock %}
